unit phpinterfacing;

Interface
{$ifdef fpc}
{$mode delphi}
{$endif}

function phpserialize   (v:variant):String;
function phpunserialize (const s : string):variant;

Implementation

Uses Variants,SysUtils;

function phpunserialize (const s : string):variant;

var i,l:integer;

function consumefield:variant; forward;

function consumearray:variant;

var j,k,fields : integer;

begin
  inc(i,2);
  j:=i;
  while (j<l) and (s[j] in ['0'..'9']) do inc(j);
  fields:=strtointdef(copy(s,i,j-i),0);
  i:=j+2;
  result:=vararraycreate([0,fields-1],varvariant);
  for j:=0 to fields-1 do
    begin
      inc(i,2);
      k:=i;
      while (k<l) and (s[k] in ['0'..'9']) do
        inc(k);
      i:=k+1;
      result[j]:=consumefield;
     end;
end;

function consumestring:variant;

var j,len : integer;
    s2 : string;
begin
  inc(i,2);
  j:=i;
  while (j<l) and (s[j] in ['0'..'9']) do inc(j);
  len:=strtointdef(copy(s,i,j-i),0);
  i:=j;
  s2:=copy(s,i+2,len);
  result:=s2;
  inc(i,len+4); // +2 are the quotes, + two :
end;

function consumeinteger:variant;

var j,len : integer;

begin
  inc(i,2);
  j:=i;
  while (j<l) and (s[j] in ['-','0'..'9']) do inc(j);
  result:=strtointdef(copy(s,i,j-i),0);
  i:=j+1;
end;

function consumeboolean:variant;

var j,len : integer;

begin
  inc(i,2);
  j:=i;
  while (j<l) and (s[j] in ['-','0'..'9']) do inc(j);
  if j<>(i+1) then
    raise EConvertError.create('not a boolean');
  result:=s[i]='1';
  i:=j+1;
end;

function consumedouble:variant;

var j,len : integer;

begin
  inc(i,2);
  j:=i;
  while (j<l) and (s[j] in ['.','E','e','-','0'..'9']) do inc(j);
  result:=strtofloat(copy(s,i,j-i));
  i:=j+1;
end;

function consumefield:variant;

begin
  case s[i] of
     'a' : result:=consumearray;
     's' : result:=consumestring;
     'b' : result:=consumeboolean;
     'i' : result:=consumeinteger;
     'd' : result:=consumedouble; 
     'n' : begin
	     result:=varnull;
             inc(i,2); // ; also
	   end;
    end;
end;

begin
  i:=1; l:=length(s);
  if i<l then  // tokens are >1
    result:=consumefield;
end;

function phpserialize   (v:variant):String;

function servariant(v:variant):string; forward;

function servarray(v:variant):string;

var i : integer;

begin
  result:='a:' +inttostr(vararrayhighbound(v,1)-vararraylowbound(v,1)+1)+':{';;
  for i:=VarArrayLowBound(v,1) to vararrayhighbound(v,1) do
    result:=result+'i:'+inttostr(i)+':'+servariant(v[i])+';';
  result:=result+'}';
end;

const booltonumber : array[boolean] of char = ('0','1');

function servariant(v:variant):string;

var i : integer;

begin
  result:='';
  i:=VarType(v);
  if (i and vararray)=vararray then
   i:=vararray;
  case i of
   varinteger :  result:='i:'+vartostr(v);	// was inttostr(vr)
   varolestr,
   varstring  :  result:='s:'+inttostr(length(v))+':"'+vartostr(v)+'"';     // why vartostr needed?
   vararray   :  result:=servarray(v);
   varnull    :  result:='N';
   vardouble  :  result:='d:'+floattostr(extended(v));   // why typecast needed?
   varboolean :  result:='b:'+booltonumber[boolean(v)];  // why typecast needed?
   end;
end;

begin
 result:=servariant(v);
end;

end.
